<div class="user-work-time-reports mb-5">
  <div class="container">

    <h1 class="mat-h1">Moje raporty</h1>
    <mat-divider class="mb-2"></mat-divider>

    <mat-card>
      <div class="search-div">
        <button mat-raised-button (click)="onCreateReportDialog()">
          <mat-icon>add</mat-icon>
          Dodaj nowy raport
        </button>
        <mat-form-field class="search-form-field">
          <input matInput [(ngModel)]="searchKey" placeholder="Wyszukaj wniosek po wybranej frazie" autocomplete="off"
                 (keyup)="applyFilter()">
          <button mat-button matSuffix mat-icon-button aria-label="Wyczyść" *ngIf="searchKey" (click)="onSearchClear()">
            <mat-icon>close</mat-icon>
          </button>
        </mat-form-field>
      </div>

      <div class="mat-elevation-z8">
        <mat-table mat-table [dataSource]="userWorkTimeRecordsDataSource" matSort>

          <ng-container matColumnDef="project">
            <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Projekt</mat-header-cell>
            <mat-cell mat-cell *matCellDef="let element"> {{element?.project.name}} </mat-cell>
          </ng-container>

          <ng-container matColumnDef="message">
            <mat-header-cell mat-header-cell *matHeaderCellDef> Treść</mat-header-cell>
            <mat-cell mat-cell *matCellDef="let element"> {{element?.message}} </mat-cell>
          </ng-container>

          <ng-container matColumnDef="type">
            <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Typ</mat-header-cell>
            <mat-cell mat-cell *matCellDef="let element">
              <ng-container *ngIf="element?.type === 'nominal'">
                Nominalny
              </ng-container>
              <ng-container *ngIf="element?.type === 'nominalCopyright'">
                Nominalny/Prawa Autorskie
              </ng-container>
              <ng-container *ngIf="element?.type === 'overtime50'">
                Nadgodziny 50%
              </ng-container>
              <ng-container *ngIf="element?.type === 'overtime100'">
                Nadgodziny 100%
              </ng-container>
            </mat-cell>
          </ng-container>

          <ng-container matColumnDef="time">
            <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Czas</mat-header-cell>
            <mat-cell mat-cell *matCellDef="let element"> {{element?.time}} g.</mat-cell>
          </ng-container>

          <ng-container matColumnDef="reportForDate">
            <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Raport za dzień</mat-header-cell>
            <mat-cell mat-cell *matCellDef="let element"> {{element?.reportForDate | date: 'd/MM/yyyy' }} </mat-cell>
          </ng-container>

          <ng-container matColumnDef="createdAt">
            <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Utworzono</mat-header-cell>
            <mat-cell mat-cell *matCellDef="let element"> {{element?.createdAt | date: 'd/MM/yyyy, h:mm'}} </mat-cell>
          </ng-container>

          <ng-container matColumnDef="updatedAt">
            <mat-header-cell mat-header-cell *matHeaderCellDef mat-sort-header> Edytowano</mat-header-cell>
            <mat-cell mat-cell *matCellDef="let element"> {{element?.updatedAt | date: 'd/MM/yyyy, h:mm'}} </mat-cell>
          </ng-container>

          <ng-container matColumnDef="actions">
            <mat-header-cell *matHeaderCellDef></mat-header-cell>
            <mat-cell *matCellDef="let row">
              <button mat-icon-button (click)="onUpdateReportDialog(row)">
                <mat-icon matTooltip="Edytuj raport">edit</mat-icon>
              </button>
              <button mat-list-icon mat-icon-button color="warn"   matTooltip="Usuń raport czasu pracy"
                      (click)="onRemoveReport(row)">
                <mat-icon>delete_outline</mat-icon>
              </button>
            </mat-cell>
          </ng-container>

          <ng-container matColumnDef="loading">
            <mat-footer-cell *matFooterCellDef>
              Ładowanie danych...
            </mat-footer-cell>
          </ng-container>

          <ng-container matColumnDef="noData">
            <mat-footer-cell *matFooterCellDef>
              Brak danych.
            </mat-footer-cell>
          </ng-container>

          <mat-header-row mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
          <mat-row mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>

          <mat-footer-row *matFooterRowDef="['loading']"
                          [ngClass]="{'none':userWorkTimeRecordsDataSource!=null}"></mat-footer-row>
          <mat-footer-row *matFooterRowDef="['noData']"
                          [ngClass]="{'none':!(userWorkTimeRecordsDataSource!=null && userWorkTimeRecordsDataSource.data.length==0)}"></mat-footer-row>
        </mat-table>

        <mat-paginator [pageSizeOptions]="[5, 10, 25, 100]" [pageSize]="10" showFirstLastButtons></mat-paginator>

      </div>
    </mat-card>

  </div>
</div>
